       ;Program to compare any two files on a disk.
 ;They may be the same or different disks. The
 ;result will be displayed on the video monitor.
 ;<c>1984 by Mel Patrick
 	ORG	8000H		;temp origin
 COMPAR	CALL	01C9H		;clear the video
 	LD	HL,MENU		;point to menu
 	CALL	DISPLY		;show it
 	LD	HL,FILE1	;point to first buffer
 	LD	B,20		;bytes to get
 	CALL	05D9H		;get input
 	JR	C,COMPAR	;back if break
 	LD	HL,MENU1	;point to second
 	CALL	DISPLY		;show it
 	LD	HL,FILE2	;point to second
 	LD	B,20		;bytes to input
 	CALL	05D9H		;get input
 	JP	C,COMPAR	;back if break
 	LD	HL,FILE1	;point to file 1
 	LD	DE,DCB1		;point to contrl 1
 	CALL	441CH		;create it
 	LD	HL,FILE2	;point to second
 	LD	DE,DCB2		;point to control 2
 	CALL	441CH		;create it
 	LD	HL,BUFF1	;point to file 1
 	LD	DE,DCB1		;point to filename
 	LD	B,00H		;set LRL=256
 	CALL	4424H		;open don't create
 	JP	NZ,ERROR	;go if error
 	LD	IX,DCB1		;point to dcb
 	LD	L,(IX+12)	;get LSB last record
 	LD	H,(IX+13)	;get MSB last record
 	INC	HL		;add 1 for read
 	LD	A,(IX+8)	;EOF byte last record
 	LD	(EOF),A		;and save it
 	LD	(LAST),HL	;save it
 	LD	HL,BUFF2	;point to second buffer
 	LD	DE,DCB2		;point to other filename
 	LD	B,00H		;set LRL=256
 	CALL	4424H		;open don't create
 	JP	NZ,ERROR	;go if error
 	LD	HL,0000H	;set record to zero
 	LD	(RECORD),HL	;save it
 	LD	HL,(LAST)	;get number of records
 	LD	A,H		;test for 1 sector only
 	OR	L		;last 1
 	JR	NZ,READLP	;go if more than 1
 	CALL	SETREC		;else set record
 	CALL	READ1		;read  in first
 	CALL	READ2		;read in second
 	JR	SECT1		;and continue
 READLP	CALL	SETREC		;set record number
 	CALL	READ1		;else go read 1
 	CALL	READ2		;and read 2
 	LD	B,00H		;bytes to check
 	CALL	VERIFY		;verify sectors now
 	LD	HL,(LAST)	;get record read
 	DEC	HL		;minus 1 from it
 	LD	(LAST),HL	;save it
 	LD	A,H		;test for last sector
 	OR	L		;0=last 1
 	JR	NZ,READLP	;continue if not done
 SECT1	LD	A,(EOF)		;else get EOF byte
 	OR	A		;any there?
 	JR	Z,SKIP		;go if not
 	LD	B,A		;set up compare loop
 	CALL	VERIFY		;and verify it
 SKIP	LD	HL,GOOD		;point to good
 	CALL	DISPLY		;show it
 	JP	402DH		;back to Dos now
 SETREC	LD	IX,DCB1		;point to first file
 	LD	HL,(RECORD)	;get record number
 	LD	(IX+10),L	;set LSB
 	LD	(IX+11),H	;set MSB
 	LD	IX,DCB2		;point to second file
 	LD	(IX+10),L	;set LSB
 	LD	(IX+11),H	;set MSB
 	INC	HL		;point to next record
 	LD	(RECORD),HL	;save it
 	RET			;and back to caller
 READ1	LD	DE,DCB1		;point to file
 	CALL	4436H		;read in 1 sector
 	RET			;back to caller
 READ2	LD	DE,DCB2		;point to second file
 	CALL	4436H		;read in second file
 	RET			;back to caller
 VERIFY	LD	HL,BUFF1	;point to first buffer
 	LD	DE,BUFF2	;point to second
 VRLP	LD	A,(DE)		;get a byte
 	CP	(HL)		;check for match
 	JR	NZ,DERROR	;go if not a match
 	LD	A,(3C3FH)	;get byte
 	XOR	0AH		;toggle a *
 	LD	(3C3FH),A	;put it back
 	INC	DE		;else point to next
 	INC	HL		;and here
 	DJNZ	VRLP		;loop til done
 	RET			;back to caller
 DERROR	POP	AF		;fix the stack
 	LD	HL,BAD		;point to message
 	CALL	DISPLY		;show it
 	JP	402DH		;back to dos
 ERROR	SET	7,A		;set return
 	CALL	4409H		;show it
 	CALL	49H		;wait for a key
 	AND	5FH		;convert
 	CP	'R'		;repeat?
 	JP	Z,COMPAR	;loop if yes
 	JP	402DH		;else re-enter DOS
 DISPLY	LD	A,(HL)		;get a byte
 	CP	03H		;end of message
 	RET	Z		;back if yes
 	CALL	33H		;else print it
 	INC	HL		;point to next
 	JR	DISPLY		;loop til done
 MENU	DEFM	'             File Comparison Utility - Version 1.0'
 	DEFB	0DH
 	DEFM	'                  <c> 1984 by Mel Patrick'
 	DEFW	0D0DH
 	DEFM	'Filespec 1 : '
 	DEFB	03H
 MENU1	DEFB	0DH
 	DEFM	'Filespec 2 : '
 	DEFB	03H
 GOOD	DEFW	0D0DH
 	DEFM	'* * Files Match * *'
 	DEFB	0DH
 	DEFB	03H
 BAD	DEFW	0D0DH
 	DEFM	'---> Files DO NOT MATCH !!!!'
 	DEFB	0DH
 	DEFB	03H
 LAST	DEFW	0000H
 RECORD	DEFW	0000H
 EOF	DEFB	00H
 FILE1	DEFS	20H		;file 1 name
 FILE2	DEFS	20H		;file 2 name
 DCB1	DEFS	50		;control block 1
 DCB2	DEFS	50		;"	"	2
 BUFF1	DEFS	256		;buffer 1
 BUFF2	DEFS	256		;buffer 2
 	END	COMPAR

